#ifndef _MENUS_H_
#define _MENUS_H_

#include <allegro.h>
#include <tdgui.h>

char* PlayerListGetter(int index, int* list_size);
extern char scrx_buf[5];
extern char scry_buf[5];

DIALOG mainmenu[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  324,  220,     0,  0,    0,BW_BUFFERED,  0,    0,  (void*)"DeathWorms"},
  {d_ex_billbutton_proc,310,    2,   10,   10,     0,  0,  'x',        0,    0,    5,  (void*)"x", SetRet, NULL},

  {d_billctext_proc,    162,   24,    8,   12,     0,  0,    0,        0,    0,    0,  "Players -- Click to Select"},
  {d_billlist_proc,       8,   32,  308,   76,     0,  0,    0,        0,    0,    0,  PlayerListGetter},
  {d_ex_billbutton_proc,  8,  112,   98,   16,     0,  0,  'a',        0,    0,    2,  "&Add", SetRet, NULL},
  {d_ex_billbutton_proc,113,  112,   98,   16,     0,  0,  'e',        0,    0,    3,  "&Edit", SetRet, NULL},
  {d_ex_billbutton_proc,218,  112,   98,   16,     0,  0,  'd',        0,    0,    4,  "&Delete", SetRet, NULL},
  {d_ex_billbutton_proc,  8,  136,   98,   16,     0,  0,  'v',        0,    0,    6,  "De/Acti&vate", SetRet, NULL},
  {d_ex_billbutton_proc,113,  136,   98,   16,     0,  0,  'p',        0,    0,    1,  "&Play", SetRet, NULL},
  {d_ex_billbutton_proc,218,  136,   98,   16,     0,  0,  'q',        0,    0,    5,  "&Quit", SetRet, NULL},

  {d_billctext_proc,     73,  160,   52,   12,     0,  0,    0,        0,    0,    0,  "Screen Resolution"},
  {d_billedit_proc,      21,  170,   44,   12,     0,  0,    0,        0,    4,    0,  scrx_buf},
  {d_billctext_proc,     73,  174,   52,   12,     0,  0,    0,        0,    0,    0,  "X"},
  {d_billedit_proc,      81,  170,   44,   12,     0,  0,    0,        0,    4,    0,  scry_buf},

  {d_billcheck_proc,    189,  170,  104,   12,     0,  0,  'm',        0,    1,    0,  "&Mortar Fire"},

  {d_billctext_proc,     73,  190,   52,   12,     0,  0,    0,        0,    0,    0,  "Game Speed"},
  {d_billslider_proc,     8,  200,  130,   12,     0,  0,    0,        0,MAX_SPEED,0,  NULL, NULL},

  {d_billctext_proc,    251,  190,   52,   12,     0,  0,    0,        0,    0,    0,  "Mortar Delay"},
  {d_billslider_proc,   186,  200,  130,   12,     0,  0,    0,        0,CRATER_RANGE,0,  NULL, NULL},

  {d_check_exit,          0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

//These have to be defines since if they were declared as vars, there would be
// multiple instances, and if they were defined in another file it would be
// tacky not being in context

#define gui_player_selected mainmenu[3].d1
#define gui_crater_checkbox mainmenu[14].flags
#define gui_gamespeed       mainmenu[16].d2
#define gui_mortarrate      mainmenu[18].d2

#endif //#ifndef _MENUS_H_